Code

bundle, fast-import: detect write failure
[git.git] / git-sh-setup.sh
index 185c5c6c95df389e0d7f39f47feeabbe67124e80..aae14090bd884920c7b5cb7530db66719df98ddd 100755 (executable)
@@ -6,7 +6,7 @@
 # it dies.
 
 # Having this variable in your environment would break scripts because
-# you would cause "cd" to be be taken to unexpected places.  If you
+# you would cause "cd" to be taken to unexpected places.  If you
 # like CDPATH, define it for your interactive shell sessions without
 # exporting it.
 unset CDPATH
@@ -16,9 +16,41 @@ die() {
        exit 1
 }
 
-usage() {
-       die "Usage: $0 $USAGE"
-}
+if test -n "$OPTIONS_SPEC"; then
+       usage() {
+               "$0" -h
+               exit 1
+       }
+
+       parseopt_extra=
+       [ -n "$OPTIONS_KEEPDASHDASH" ] &&
+               parseopt_extra="--keep-dashdash"
+
+       eval "$(
+               echo "$OPTIONS_SPEC" |
+                       git rev-parse --parseopt $parseopt_extra -- "$@" ||
+               echo exit $?
+       )"
+else
+       usage() {
+               die "Usage: $0 $USAGE"
+       }
+
+       if [ -z "$LONG_USAGE" ]
+       then
+               LONG_USAGE="Usage: $0 $USAGE"
+       else
+               LONG_USAGE="Usage: $0 $USAGE
+
+$LONG_USAGE"
+       fi
+
+       case "$1" in
+               -h|--h|--he|--hel|--help)
+               echo "$LONG_USAGE"
+               exit
+       esac
+fi
 
 set_reflog_action() {
        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
@@ -91,41 +123,28 @@ get_author_ident_from_commit () {
        LANG=C LC_ALL=C sed -ne "$pick_author_script"
 }
 
-if [ -z "$LONG_USAGE" ]
-then
-       LONG_USAGE="Usage: $0 $USAGE"
-else
-       LONG_USAGE="Usage: $0 $USAGE
-
-$LONG_USAGE"
-fi
-
-case "$1" in
-       -h|--h|--he|--hel|--help)
-       echo "$LONG_USAGE"
-       exit
-esac
-
-# Make sure we are in a valid repository of a vintage we understand.
-if [ -z "$SUBDIRECTORY_OK" ]
+# Make sure we are in a valid repository of a vintage we understand,
+# if we require to be in a git repository.
+if test -z "$NONGIT_OK"
 then
-       : ${GIT_DIR=.git}
-       GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
-               exit=$?
-               echo >&2 "You need to run this command from the toplevel of the working tree."
-               exit $exit
-       }
-else
-       GIT_DIR=$(git rev-parse --git-dir) || {
-           exit=$?
-           echo >&2 "Failed to find a valid git directory."
-           exit $exit
+       if [ -z "$SUBDIRECTORY_OK" ]
+       then
+               : ${GIT_DIR=.git}
+               test -z "$(git rev-parse --show-cdup)" || {
+                       exit=$?
+                       echo >&2 "You need to run this command from the toplevel of the working tree."
+                       exit $exit
+               }
+       else
+               GIT_DIR=$(git rev-parse --git-dir) || {
+                   exit=$?
+                   echo >&2 "Failed to find a valid git directory."
+                   exit $exit
+               }
+       fi
+       test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
+               echo >&2 "Unable to determine absolute path of git directory"
+               exit 1
        }
+       : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
 fi
-
-test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
-    echo >&2 "Unable to determine absolute path of git directory"
-    exit 1
-}
-
-: ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}